--- mozilla/mailnews/mime/src/mimei.cpp.orig	2008-07-11 16:12:49.000000000 +0200
+++ mozilla/mailnews/mime/src/mimei.cpp	2008-07-11 16:59:07.000000000 +0200
@@ -450,6 +450,7 @@
   MimeObjectClass *clazz = 0;
   MimeObjectClass *tempClass = 0;
   contentTypeHandlerInitStruct  ctHandlerInfo;
+  char *override_content_type = 0;

   // Read some prefs
   nsIPrefBranch *prefBranch = GetPrefBranch(opts);
@@ -722,6 +723,22 @@
         /* Treat all unknown message subtypes as "text/plain" */
         clazz = (MimeObjectClass *)&mimeInlineTextPlainClass;
     }
+
+    /* Sometimes, the mailer puts a binary Content-Type for a valid image.
+       It seems really strange for a user, which sees not all pictures.
+       This part set it correctly so it can be processed and displayed correctly
+       afterwards. */
+    else if (!nsCRT::strcasecmp(content_type, APPLICATION_OCTET_STREAM))
+    {
+	  char *name = MimeHeaders_get_name(hdrs, opts);
+	  if (name)
+		{
+		  override_content_type = opts->file_type_fn (name, opts->stream_closure);
+		  PR_FREEIF(name);
+          if (!nsCRT::strncasecmp(override_content_type,      "image/", 6))
+            content_type = override_content_type;
+        }
+    }

     /* The magic image types which we are able to display internally...
     */
@@ -774,6 +791,10 @@
   }
 #endif

+  if (override_content_type)
+    PR_FREEIF(override_content_type);
+
+
   if (!exact_match_p)
     NS_ASSERTION(clazz, "1.1 <rhp@netscape.com> 19 Mar 1999 12:00");
   if (!clazz) return 0;
